//
//  YouTubeViewController.m
//  Ambassadors
//
//  Created by Kimberly Hsiao on 6/18/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "YouTubeViewController.h"

@interface YouTubeViewController ()

@property (nonatomic, strong) NSURLConnection* youtubeFavsConnection;
@property (nonatomic, strong) NSMutableData *youtubeFavsResponseData;
@property (nonatomic, strong) NSMutableArray* videoURLs;

@end

@implementation YouTubeViewController

@synthesize youtubeWebView = _youtubeWebView;
@synthesize nextButton = _nextButton;
@synthesize youtubeFavsConnection = _youtubeFavsConnection;
@synthesize youtubeFavsResponseData = _youtubeFavsResponseData;
@synthesize videoURLs = _videoURLs;

#pragma mark - getters and setters

- (NSMutableData*)youtubeFavsResponseData {
    if (!_youtubeFavsResponseData) {
        _youtubeFavsResponseData = [[NSMutableData alloc] init];
    }
    return _youtubeFavsResponseData;
}

- (NSMutableArray*)videoURLs {
    if (!_videoURLs) {
        _videoURLs = [[NSMutableArray alloc] init];
    }
    return _videoURLs;
}

#pragma mark - nsurlconnection delegate methods

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
    [self.youtubeFavsResponseData setLength:0];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    [self.youtubeFavsResponseData appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
    if (connection == self.youtubeFavsConnection) {
        NSLog(@"Youtube Favorites connection error");
    }
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
    
    if (connection == self.youtubeFavsConnection) {
        NSError *error = nil;
        NSDictionary *youtubeFavsDict = [NSJSONSerialization JSONObjectWithData:self.youtubeFavsResponseData options:NSJSONWritingPrettyPrinted error:&error];
//        NSLog(@"youtube dict is %@",youtubeFavsDict);
        
        NSArray *videoArray = [[youtubeFavsDict objectForKey:@"feed"] objectForKey:@"entry"];
        for (NSDictionary* video in videoArray) {
            NSArray* videoTypesArray = [[video objectForKey:@"media$group"] objectForKey:@"media$content"];
            for (NSDictionary* videoType in videoTypesArray) {
                if ([[videoType objectForKey:@"type"] isEqualToString:@"application/x-shockwave-flash"]) {
                    [self.videoURLs addObject:[videoType objectForKey:@"url"]];
                }
            }
        }
        
//        NSLog(@"video urls is %@",self.videoURLs);
//        NSLog(@"number of videos is %i",[self.videoURLs count]);
        
        NSString *htmlString = [NSString stringWithFormat:@"<html><head>"
        "<meta name = \"viewport\" content = \"initial-scale = 1.0, user-scalable = no, width = 90\"/></head>"
        "<body style=\"background:#F00;margin-top:0px;margin-left:0px\">"
        "<div><object width=\"90\" height=\"60\">"
        "<param name=\"movie\" value=\"%@\"></param>"
        "<param name=\"wmode\" value=\"transparent\"></param>"
        "<embed src=\"%@\""
        "type=\"application/x-shockwave-flash\" wmode=\"transparent\" width=\"90\" height=\"60\"></embed>"
                                "</object></div></body></html>",[self.videoURLs objectAtIndex:0],[self.videoURLs objectAtIndex:0]];
        
        [self.youtubeWebView loadHTMLString:htmlString baseURL:[NSURL URLWithString:@"http://www.your-url.com"]];
    }
}

#pragma mark - view lifecycle

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // call youtube api to get my favorites
    NSString* myUID = @"kimikul";
    NSString *youtubeFavsQuery = [NSString stringWithFormat:@"https://gdata.youtube.com/feeds/api/users/%@/favorites?v=2&alt=json",myUID];
    
    NSURLRequest *youtubeFavsRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:youtubeFavsQuery]];
    NSURLConnection *youtubeFavsConnection = [[NSURLConnection alloc] initWithRequest:youtubeFavsRequest delegate:self];
    self.youtubeFavsConnection = youtubeFavsConnection;
}

- (void)viewDidUnload
{
    [self setYoutubeWebView:nil];
    [self setNextButton:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
